class Database

  attr_reader :name, :connection, :tables, :relations

  def initialize(name)
    @name = name

    begin
      open_connection(@name)
      puts "... Inspecting database #{@name}"

      find_tables
      puts "... Found #{@tables.size} tables"

      find_relations
      puts "... Found #{@relations.size} relations"
    rescue Exception => e
      puts "... Error FATAL: #{e}"
      exit(1)
    end
  end

  private

  def open_connection(database_name)
    raise NotImplementedError.new("Feature Not Yet Implemented")
  end

  def find_tables
    raise NotImplementedError.new("Feature Not Yet Implemented")
  end

  def find_relations
    raise NotImplementedError.new("Feature Not Yet Implemented")
  end
end